# Source code for azure.graphrbac.operations.deleted_applications_operations

    # coding=utf-8
    # --------------------------------------------------------------------------
    # Copyright (c) Microsoft Corporation. All rights reserved.
    # Licensed under the MIT License. See License.txt in the project root for
    # license information.
    #
    # Code generated by Microsoft (R) AutoRest Code Generator.
    # Changes may cause incorrect behavior and will be lost if the code is
    # regenerated.
    # --------------------------------------------------------------------------

    import uuid
    from msrest.pipeline import ClientRawResponse

    from .. import models

    class DeletedApplicationsOperations(object):
        """DeletedApplicationsOperations operations.

        :param client: Client for service requests.
        :param config: Configuration of service client.
        :param serializer: An object model serializer.
        :param deserializer: An object model deserializer.
        :ivar api_version: Client API version. Constant value: "1.6".
        """

        models = models

        def __init__(self, client, config, serializer, deserializer):

            self._client = client
            self._serialize = serializer
            self._deserialize = deserializer
            self.api_version = "1.6"

            self.config = config

        def restore(
                self, object_id, custom_headers=None, raw=False, **operation_config):
            """Restores the deleted application in the directory.

            :param object_id: Application object ID.
            :type object_id: str
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: Application or ClientRawResponse if raw=true
            :rtype: ~azure.graphrbac.models.Application or
             ~msrest.pipeline.ClientRawResponse
            :raises:
             :class:`GraphErrorException<azure.graphrbac.models.GraphErrorException>`
            """
            # Construct URL
            url = self.restore.metadata['url']
            path_format_arguments = {
                'objectId': self._serialize.url("object_id", object_id, 'str'),
                'tenantID': self._serialize.url("self.config.tenant_id", self.config.tenant_id, 'str')
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str')

            # Construct headers
            header_parameters = {}
            header_parameters['Accept'] = 'application/json'
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct and send request
            request = self._client.post(url, query_parameters, header_parameters)
            response = self._client.send(request, stream=False, **operation_config)

            if response.status_code not in [200]:
                raise models.GraphErrorException(self._deserialize, response)

            deserialized = None

            if response.status_code == 200:
                deserialized = self._deserialize('Application', response)

            if raw:
                client_raw_response = ClientRawResponse(deserialized, response)
                return client_raw_response

            return deserialized
        restore.metadata = {'url': '/{tenantID}/deletedApplications/{objectId}/restore'}

        def list(
                self, filter=None, custom_headers=None, raw=False, **operation_config):
            """Gets a list of deleted applications in the directory.

            :param filter: The filter to apply to the operation.
            :type filter: str
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: An iterator like instance of Application
            :rtype:
             ~azure.graphrbac.models.ApplicationPaged[~azure.graphrbac.models.Application]
            :raises:
             :class:`GraphErrorException<azure.graphrbac.models.GraphErrorException>`
            """
            def internal_paging(next_link=None, raw=False):

                if not next_link:
                    # Construct URL
                    url = self.list.metadata['url']
                    path_format_arguments = {
                        'tenantID': self._serialize.url("self.config.tenant_id", self.config.tenant_id, 'str')
                    }
                    url = self._client.format_url(url, **path_format_arguments)

                    # Construct parameters
                    query_parameters = {}
                    if filter is not None:
                        query_parameters['$filter'] = self._serialize.query("filter", filter, 'str')
                    query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str')

                else:
                    url = '/{tenantID}/{nextLink}'
                    path_format_arguments = {
                        'nextLink': self._serialize.url("next_link", next_link, 'str', skip_quote=True),
                        'tenantID': self._serialize.url("self.config.tenant_id", self.config.tenant_id, 'str')
                    }
                    url = self._client.format_url(url, **path_format_arguments)
                    query_parameters = {}
                    query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str')

                # Construct headers
                header_parameters = {}
                header_parameters['Accept'] = 'application/json'
                if self.config.generate_client_request_id:
                    header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
                if custom_headers:
                    header_parameters.update(custom_headers)
                if self.config.accept_language is not None:
                    header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

                # Construct and send request
                request = self._client.get(url, query_parameters, header_parameters)
                response = self._client.send(request, stream=False, **operation_config)

                if response.status_code not in [200]:
                    raise models.GraphErrorException(self._deserialize, response)

                return response

            # Deserialize response
            deserialized = models.ApplicationPaged(internal_paging, self._deserialize.dependencies)

            if raw:
                header_dict = {}
                client_raw_response = models.ApplicationPaged(internal_paging, self._deserialize.dependencies, header_dict)
                return client_raw_response

            return deserialized
        list.metadata = {'url': '/{tenantID}/deletedApplications'}

        def hard_delete(
                self, application_object_id, custom_headers=None, raw=False, **operation_config):
            """Hard-delete an application.

            :param application_object_id: Application object ID.
            :type application_object_id: str
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: None or ClientRawResponse if raw=true
            :rtype: None or ~msrest.pipeline.ClientRawResponse
            :raises:
             :class:`GraphErrorException<azure.graphrbac.models.GraphErrorException>`
            """
            # Construct URL
            url = self.hard_delete.metadata['url']
            path_format_arguments = {
                'applicationObjectId': self._serialize.url("application_object_id", application_object_id, 'str'),
                'tenantID': self._serialize.url("self.config.tenant_id", self.config.tenant_id, 'str')
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str')

            # Construct headers
            header_parameters = {}
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct and send request
            request = self._client.delete(url, query_parameters, header_parameters)
            response = self._client.send(request, stream=False, **operation_config)

            if response.status_code not in [204]:
                raise models.GraphErrorException(self._deserialize, response)

            if raw:
                client_raw_response = ClientRawResponse(None, response)
                return client_raw_response
        hard_delete.metadata = {'url': '/{tenantID}/deletedApplications/{applicationObjectId}'}